//////////////////////////////////////////////////////////////////////////////
// Name:        SVGStopElement.h
// Author:      Alex Thuering
// Copyright:   (c) 2005 Alex Thuering
// Licence:     wxWindows licence
// Notes:       generated by generate.py
//////////////////////////////////////////////////////////////////////////////

#ifndef WX_SVG_STOP_ELEMENT_H
#define WX_SVG_STOP_ELEMENT_H

#include "SVGElement.h"
#include "SVGStylable.h"
#include "SVGAnimatedNumber.h"
#include "String.h"
#include "Element.h"

class wxSVGStopElement:
  public wxSVGElement,
  public wxSVGStylable
{
  protected:
    wxSVGAnimatedNumber m_offset;

  public:
    inline const wxSVGAnimatedNumber& GetOffset() const { return m_offset; }
    inline void SetOffset(const wxSVGAnimatedNumber& n) { m_offset = n; }
    inline void SetOffset(float n) { m_offset.SetBaseVal(n); }

  public:
    wxSVGStopElement(wxString tagName = wxT("stop")):
      wxSVGElement(tagName) {}
    virtual ~wxSVGStopElement() {}
    wxXmlNode* CloneNode(bool deep = true) { return new wxSVGStopElement(*this); }
    bool HasAttribute(const wxString& name);
    wxString GetAttribute(const wxString& name);
    bool SetAttribute(const wxString& name, const wxString& value);
    wxXmlAttrHash GetAttributes() const;
    virtual wxSVGDTD GetDtd() const { return wxSVG_STOP_ELEMENT; }
};

#endif // WX_SVG_STOP_ELEMENT_H
